package com.lantone.qc.trans.beilun.util.ez.util;

import com.google.common.collect.Maps;
import com.lantone.qc.pub.util.StringUtil;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.Node;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: HUJING
 * @time: 2021/1/4 14:30
 */
public class EzXmlUtil {

    public static Map<String, String> analysis(String xml) throws Exception {
        Map<String, String> map = Maps.newLinkedHashMap();
        Document doc = DocumentHelper.parseText(bom(xml));
        Element rootElement = doc.getRootElement();
        findAllNodes(rootElement, map);
        return map;
    }

    /**
     * 从指定节点开始,向下寻找所有节点 ，包括其子节点<br/>
     *
     * @param node 所指定的节点
     */
    public static void findAllNodes(Element node, Map<String, String> map) {

        putNode(node, map);

        // 递归遍历当前节点所有的子节点
        List<Element> listElement = node.elements();

        // 遍历所有一级子节点
        for (Element e : listElement) {
            findAllNodes(e, map);// 递归
        }
    }

    /**
     * 存放节点，不包括其子节点
     *
     * @param node 所指定的节点
     */
    public static void putNode(Element node, Map<String, String> map) {
        String labelName = node.getName();
        List<Attribute> listAttr = node.attributes();// 所有属性
        for (Attribute attr : listAttr) {// 遍历所有属性
            //String name = attr.getName();// 属性名称
            if (("fieldelem".equals(labelName)) && StringUtil.isNotBlank(attr.getValue())) {
                /*
                if (text.contains("：") && text.indexOf("：") < text.length()) {
                    text = text.substring(text.indexOf("：") + 1);
                }
                 */
                String fieldelemKey = attr.getValue();// 属性的值
                String text = node.getStringValue();
                map.put(fieldelemKey, text);
            }
            if ("section".equals(labelName)) {
                List<Element> content = node.content();
                if (content.size() > 0) {
                    Element firstEle = content.get(0);
                    String key = firstEle.getStringValue();
                    if (key.endsWith("：")) {
                        key = key.substring(0, key.length() - 1);
                    }
                    String value = "";
                    for (int i = 1; i < content.size(); i++) {
                        String v = content.get(i).getStringValue();
                        value += v + " ";
                    }
                    map.put(key, value);
                }
            }
        }
    }

    public static String bom(String result) {
        if (null != result && !"".equals(result)) {
            if (result.contains("<") && result.lastIndexOf(">") != -1 && result.lastIndexOf(">") > result.indexOf("<")) {
                result = result.substring(result.indexOf("<"), result.lastIndexOf(">") + 1);
            }
        }
        return result;
    }

    public static String elementTxt(Node node) {
        if (node != null) {
            return StringUtil.removeBlank(node.getStringValue());
        } else {
            return "";
        }
    }
}